/** Source code example for "A Practical Introduction to Data
    Structures and Algorithm Analysis, 3rd Edition (Java)" 
    by Clifford A. Shaffer, Prentice Hall, 2009.
    Copyright 2008 by Clifford A. Shaffer
*/

/** A JUnit test class for the factorial function. */

import java.io.*;
import java.math.*;

public class HashTest
    extends junit.framework.TestCase
{

// Use folding on a string, summed 4 bytes at a time
int sfold(String x, int M) {
  char ch[];
  ch = x.toCharArray();
  int intlength=x.length()/4;
  long sum=0;
  int count=0;
  for(int i=0;i<intlength;i++) {
    sum+=(((long)ch[count])<<24) +
          (((long)ch[count+1])<<16) +
          (((long)ch[count+2])<<8) +
          ((long)ch[count+3]);
    count+=4;
  }
  return(Math.abs((int)sum) % M);
}
int h(String x, int M) {
  char ch[];
  ch = x.toCharArray();
  int xlength = x.length();

  int i, sum;
  for (sum=0, i=0; i<x.length(); i++)
    sum += ch[i];
  return sum % M;
}
int h(int x) {
  return(x % 16);
}


  /**
   * This method is automatically called once before each test case
   * method, so that all the variables are cleanly initialized for
   * each test.
   */
  public void setUp()
  {
  }


  public void testHash() {
    HashTable<Integer,String> T = new HashTable<Integer,String>(101);

    System.out.println("Hello is " + h(101));
    System.out.println("Result of searching for 10 is " + T.hashSearch(10));
    System.out.println("Result of searching for 11 is " + T.hashSearch(11));
  }

}
